/* PRG 2 SID (/) iAN CooG/HVSC
   Automatically attach a PSID header to a ripped (prg) tune.
   Identifies some players and sets init/play accordingly, also patches
   the header/code if needed.
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#ifdef _WIN32
#include <windows.h>
#else
#define MAX_PATH 260
#endif

unsigned char psidh[0x7c]={
0x50,0x53,0x49,0x44,0x00,0x02,0x00,0x7C,0x00,0x00,0x10,0x00,0x10,0x03,0x00,0x01,
0x00,0x01,0x00,0x00,0x00,0x00,0x3C,0x3F,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x3F,0x3E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x31,0x39,0x3F,0x3F,0x20,0x3C,0x3F,0x3E,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x14,0x00,0x00,0x00,0x00
};
unsigned char extrabytes[16];

unsigned char aPatchSndmon[]={0xa9,0x01,0x8d,0x0f,0xc0,0xa9,0x00,0x8d,0xc6,0x02,0x60};
unsigned char aPatchRckmon[]={0xa9,0x01,0x8d,0x0f,0xc0,0x4c,0x12,0xc0};
unsigned char aPatchPolly1[]={0xa9,0x7f,0x8d,0x0d,0xdc,0xad,0x0d,0xdc,0xa0,0x00,0xea};
unsigned char aPatchPolly2[]={0xa0,0x19,0xb9,0x47,0x0b,0x99,0xff,0xd3,0x88,0xd0,0xf7,0xa9,0x00,0x8d,0x15,0xd0,0xea,0xea,0xea,0xea,0xea,0xea};
unsigned char aPatchElcSnd[]={0x48,0x20,0x18,0x00,0x68,0xaa,0x8e,0xab,0x02,0xbd,0x15,0x00,0x8d,0xff,0x02,0xa9,0x01,0x8d,0xf9,0x02,0x60,0x0a};
unsigned char aPatchUbiksM[]={0x4C,0x00,0x00,0x4C,0x00,0x00,0x18,0x69,0x80,0x8D,0x00,0x00,0xA2,0x00,0xA9,0x00,0x9D,0x00,0xD4,0xE8,0xE0,0x20,0xD0,0xF6,0x60,0xA5,0x01,0x48,0xA9,0x36,0x85,0x01,0x20,0x00,0x00,0x68,0x85,0x01,0x60};
unsigned char aPatchMastCm[]={0xA9,0x01,0x8D,0x00,0x00,0xD0,0x21,0xA9,0x00,0xD0,0x31};

char ids[30]="Generic";
unsigned char *p;

int fsiz,initaddr,playaddr,loadaddr,i,j,k,extra=0;

#define VERSION "0.90"
/*****************************************************************************/
int AdjustJ(int x,int la)
{
    x=x+2-la;
    return x;
}
/*****************************************************************************/
int CheckJ(int x, int fs)
{
    return ((x<0)||(x>(fs-1)));
}
/*****************************************************************************/
void AdjFC(void)
/*****************************************************************************/
{
    if((p[0x48]==0x20) && (p[0x49]==0xd0))
    {
        p[0x47]=0xea;
        p[0x48]=0xea;
        p[0x49]=0xea;
    }
}
/* FC 1000/1006 **************************************************************/
int Chk_FC(void)
/*****************************************************************************/
{
    if(fsiz<0x200) return 0;
    if((p[0x02]==0x4c) &&
       (p[0x08]==0xad) &&
       (p[0x0f]==0xc9) &&
       ((*(unsigned int*)(p+0x0b)&0xfffff0ff)==0x07F000C9))
    {
        playaddr=initaddr+6;
        AdjFC();
        strcpy(ids,"FutureComposer");
        return 1;
    }
    return 0;
}
/***** FC 1000/102a (MS) *****************************************************/
int Chk_FCAlt(void)
{
    if(fsiz<0x200) return 0;
    if((p[0x02]==0x4c) &&
       (p[0x03]==0x08) && /*(p[0x08]!=0xad) &&*/
       (p[0x2c]==0xee) &&
       (p[0x2d]==0x42) &&
       (p[0x2f]==0xee) &&
       (p[0x30]==0x43)
      )
    {
        playaddr=initaddr+0x2a;
        AdjFC();
        strcpy(ids,"FutureComposer");
        strcat(ids," (altered)");
        return 1;
    }
    return 0;
}
/***** MusicAss 1048/1021 ****************************************************/
int Chk_MusAss(void)
{
    if(fsiz<0x200) return 0;
    j=-1;
    for (i=2;i<0x25;i++)
    {
        if((*(unsigned int*)(p+i)==0x90CE00A2) &&
           (*(unsigned int*)(p+0x05+i)==0x26200C30) &&
           (*(unsigned int*)(p+0x31+i)==0x628D0F29))
        {
            j=i;
            break;
        }
    }
    if(j>=0)
    {
        initaddr=loadaddr+0x48-0x23+i;
        playaddr=loadaddr+0x21-0x23+i;
        strcpy(ids,"MusicAssembler");
        return 1;
    }
    return 0;
}
/***** MusicMixer 1041/107a **************************************************/
int Chk_MusMix(void)
{
    if(fsiz<0x200) return 0;
    j=-1;
    for (i=2;i<0x2d;i++)
    {
        if(p[0x43-0x2b+i]==0xa9&&
           (*(unsigned int*)(p+0x4b-0x2b+i)==0x0F29D417) &&
           (*(unsigned int*)(p+0xD4-0x2b+i)==0x2030FAB1) &&
           (*(unsigned int*)(p+0x7b-0x2b+i)==0xCE00A260))
        {
            j=i;
            break;
        }
    }
    if(j>=0)
    {
        initaddr=loadaddr+0x41-0x2b+i;
        playaddr=loadaddr+0x7a-0x2b+i;
        strcpy(ids,"MusicMixer");
        return 1;
    }
    return 0;
}
/***** GMC 18ea/14ea *********************************************************/
int Chk_GMC(void)
{
    if(fsiz<0x900) return 0;
    j=-1;
    for (i=2;i<0x18;i++)
    {
        if((*(unsigned int*)(p+0x0d0-0x16+i)==0x18FADDC3) &&
           (*(unsigned int*)(p+0x0e0-0x16+i)==0x47FBB470) &&
           (*(unsigned int*)(p+0x1a4-0x16+i)==0x0a0a0a0a))
        {
            j=i;
            break;
        }
    }
    if(j>=0)
    {
        initaddr=loadaddr+0x8ea-0x16+i;
        playaddr=loadaddr+0x4ea-0x16+i;
        strcpy(ids,"GMC/Superiors");
        return 1;
    }
    return 0;
}
/***** Bappalander 1000/1018 *************************************************/
int Chk_Bappalander(void)
{
    if(fsiz<0x400) return 0;
    if((*(unsigned int*)(p+0x002)==0x7DA200A9) &&
       (*(unsigned int*)(p+0x017)==0xCE60B185) &&
       (*(unsigned int*)(p+0x215)==0x0a0a0a0a))
    {
        initaddr=loadaddr      ;
        playaddr=loadaddr+0x18;
        strcpy(ids,"Bappalander");
        return 1;
    }
    if((p[2]==0x4c) &&
       (*(unsigned int*)(p+0x00c)==0xA9FA10CA) &&
       (*(unsigned int*)(p+0x084)==0xBDAAB0B1) &&
       (*(unsigned int*)(p+0x25a)==0x0a0a0a0a))
    {
        initaddr=loadaddr+3   ;
        playaddr=loadaddr+0   ;
        strcpy(ids,"Bappalander");
        strcat(ids,"/SpaceLab");
        return 1;
    }
    return 0;
}
/***** Trackplayer 1140/1287 *************************************************/
int Chk_TrkPl3(void)
{
    if(fsiz<0x500) return 0;
    if((*(unsigned int*)(p+0x142)==0x00A900A2) &&
       (*(unsigned int*)(p+0x148)==0x20E0E8D4) &&
       (*(unsigned int*)(p+0x289)==0xCA2000A2) &&
       (*(unsigned int*)(p+0x491)==0x0a0a0a0a))
    {
        initaddr=loadaddr+0x140;
        playaddr=loadaddr+0x287;
        strcpy(ids,"TrackPlayer");
        return 1;
    }
    return 0;
}
/***** Groovy bits 1003/1000 *************************************************/
int Chk_Groovy(void)
{
    if(fsiz<0x200) return 0;
    if((p[2]==0x4c) &&
       (*(unsigned int*)(p+0x005)==0x9D8A00A2) )
    {
        j=0;
        k=(p[4]<<8)+p[3]-loadaddr+2;
        if((*(unsigned int*)(p+k)&0xfffff0ff)==0xAD0330EE)
        {
            j=1;
        }
        else if((p[k     ]==0xe6)&&
                (p[k+0x02]==0xa5)&&
                (p[k+0x01]==p[k+0x03])&&
                (p[k+0x04]==0xc9))
        {
            j=2;
        }
        if(j>0)
        {
            initaddr=loadaddr+3;
            playaddr=loadaddr+0;
            sprintf(ids,"GroovyBits v%d",j);
            return 1;
        }
    }
    return 0;
}
/***** Parsec (LoS) 1003/1000 ************************************************/
int Chk_Parsec(void)
{
    if(fsiz<0x200) return 0;
    if((*(unsigned int*)(p+0x0d8)==0x06ADF4F2) &&
       (*(unsigned int*)(p+0x0e0)==0xD002C974) &&
       (*(unsigned int*)(p+0x0f4)==0x180A0A00) )
    {
        initaddr=loadaddr+3;
        playaddr=loadaddr+0;
        strcpy(ids,"Parsec/LoS");
        return 1;
    }
    return 0;
}
/***** Sosperec: TAX+1103/1100 ***********************************************/
int Chk_Sosperec(void)
{
    if(fsiz<0x200) return 0;
    if((*(unsigned int*)(p+0x010)==0x02020202) &&
      ((*(unsigned int*)(p+0x102)&0xff00ffff)==0x8E00AA4C) &&
       (*(unsigned int*)(p+0x132)==0xD4168ED4))
    {
        initaddr=loadaddr+0xfc;
        playaddr=loadaddr+0x100;
        p[0x0fe]=0xaa;
        p[0x0ff]=0x4c;
        p[0x100]=0x03;
        p[0x101]=(loadaddr+0x100)>>8;
        strcpy(ids,"Sosperec");
        return 1;
    }
    return 0;
}
/***** Soedesoft+hacks *******************************************************/
int Chk_SoedeSoft(void)
{
    if(fsiz<0x200) return 0;
    if(((*(unsigned int*)(p+0x02b)&0xfffff0ff)==0x3399A0A0) &&
        (*(unsigned int*)(p+0x02f)==0xFAD08803) &&
        (*(unsigned int*)(p+0x107)==(0x00DA2060|((loadaddr>>8)<<24))) )
    {
        if(p[2]==0x4c)
        {
            initaddr=loadaddr;
            p[3]=0x29;
            p[4]=loadaddr>>8;
        }
        else
            initaddr=loadaddr+0x29;

        playaddr=loadaddr+0x106;
        p[0xda]=0x60;
        if(p[0x142]==0xa9)/* end of irq d019/ea31 */
        {
            for(j=0x142;j<0x14a;j++)
                p[j]=0x60;
        }
        strcpy(ids,"Soedesoft");strcat(ids," v1");
        return 1;
    }
    if((p[2]==0x4c) &&
       (p[5]==0x4c) &&
       (p[8]==0x4c) &&
       (*(unsigned int*)(p+0x01a)==0x88033399) &&
       (*(unsigned int*)(p+0x01e)==0x00A9FAD0))
    {
        initaddr=loadaddr;
        if(p[0x6]==0x7b)
            playaddr=loadaddr+3;
        else if(p[0x9]==0x7b)
            playaddr=loadaddr+6;
        else
            playaddr=loadaddr+0x7b;
        p[0x5c]=0x60;
        strcpy(ids,"Soedesoft");strcat(ids," v2");
        return 1;
    }
    if((p[2]==0x4c) &&
       (p[5]==0x4c) &&
       (p[6]==0x35) &&
       (p[8]==0x4c) &&
       (p[9]==0x7c) &&
       (*(unsigned int*)(p+0x03b)==0x88033399) &&
       (*(unsigned int*)(p+0x07d)==0x037CEE60))
    {
        initaddr=loadaddr+3;
        playaddr=loadaddr+6;
        strcpy(ids,"Soedesoft");strcat(ids," v3");
        return 1;
    }
    return 0;
}
/***** Prosonix 1000/1009 ****************************************************/
int Chk_Prosonix1(void)
{
    if(fsiz<0x200) return 0;
    if((p[2]==0x4c) &&
       (p[5]==0x4c) &&
       (p[8]==0x4c) &&
      ((*(unsigned int*)(p+0x00b)&0x00ffffff)==0x00F000A9) &&
      ((*(unsigned int*)(p+0x00f)&0x00ff00ff)==0x00600010))
    {
        j=AdjustJ(p[3]|p[4]<<8,loadaddr);
        if( !CheckJ(j,fsiz) )
        {
            if((p[j+0x00]==0xa9) &&
               (p[j+0x01]==0x01) &&
               (p[j+0x02]==0x8d) &&
               (p[j+0x05]==0xa2) )
            {
                initaddr=loadaddr+0;
                playaddr=loadaddr+9;
                strcpy(ids,"Prosonix");strcat(ids," v1");
                return 1;
            }
        }
    }
    return 0;
}
/* 4 JMPS ********************************************************************/
int Chk_4JMPS(void)
{
    if(fsiz<0x800) return 0;
    if((p[0x2]==0x4c) &&
       (p[0x5]==0x4c) &&
       (p[0x8]==0x4c) &&
       (p[0xb]==0x4c))
    {
        j=AdjustJ(p[3]|p[4]<<8,loadaddr);
        if( !CheckJ(j,fsiz) )
        {
            if(*(unsigned int*)(p+j)==0x0C8D03A9)
            {
                j=AdjustJ(p[0xc]|p[0xd]<<8,loadaddr);
                if( !CheckJ(j,fsiz) )
                {
                    if((p[j+0]==0xad) &&
                       (p[j+1]==0x0c) &&
                       (p[j+3]==0xf0) &&
                       (p[j+8]==0x4c))
                    {
                        initaddr=loadaddr+0;
                        playaddr=loadaddr+9;
                        strcpy(ids,"Prosonix");strcat(ids," v2");
                        return 1;
                    }
                }
            }
/***** TFMX/Huelsbeck 1009/1000 **********************************************/
            if((p[j+0x00]==0xad)&&
               (p[j+0x03]==0x30)&&
               (p[j+0x05]==0x20))
            {
                j=AdjustJ(p[0xc]|p[0xd]<<8,loadaddr);
                if((p[j+0x00]==0x8d) &&
                   (p[j+0x03]==0x8e) &&
                   (p[j+0x06]==0x60) &&
                   ((p[j+0x07]==0x18) ||(p[j+0x0c]==0x18)) )
                {
                    initaddr=loadaddr+9;
                    playaddr=loadaddr+0;
                    strcpy(ids,"TFMX/Huelsbeck");
                    return 1;
                }
            }
/***** Heathcliff/DigitalArts 1009/1000 **************************************/
/***** "Forgot to give a name player Rene Lergner"****************************/
            if(((*(unsigned int*)(p+j+0   )&0xffff00ff)==0xFBF000A9)&&
               ((*(unsigned int*)(p+j+0x04)&0x00fff0ff)==0x008d00a9)&&
               ((*(unsigned int*)(p+j+0x09)&0x00ffffff)==0x002000a2)&&
               ((*(unsigned int*)(p+j+0x0e)&0x00ffffff)==0x002007a2)
              )
            {
                initaddr=loadaddr+9;
                playaddr=loadaddr+0;
                strcpy(ids,"Heathcliff");strcat(ids," v1");
                return 1;
            }
        }
    }
    return 0;
}
/***** Heathcliff/DigitalArts v3 1003/1000 **************************************/
int Chk_Heathcliff(void)
{
    if(fsiz<0x800) return 0;
    if((p[0x2]==0x4c) &&
       (p[0x5]==0xa9) &&
       (p[0xa]==0xa2) )
    {
        j=AdjustJ(p[3]|p[4]<<8,loadaddr);
        if( !CheckJ(j,fsiz) )
        {
            if(((*(unsigned int*)(p+j+0   )&0x00ffffff)==0x00F015A9) &&
               ((*(unsigned int*)(p+j+0x04)&0x00ffffff)==0x002000a2)&&
               ((*(unsigned int*)(p+j+0x09)&0x00ffffff)==0x002007a2)
              )
            {
                initaddr=loadaddr+3;
                playaddr=loadaddr+0;
                strcpy(ids,"Heathcliff");strcat(ids," v3");
                return 1;
            }
        }
    }
    return 0;
}
/***** Prosonix v3 1000/1006 *************************************************/
int Chk_3JMPs1(void)
{
    if(fsiz<0x400) return 0;
    if((p[0x2]==0x4c) &&
       (p[0x5]==0x4c) &&
       (p[0x8]==0x4c) &&
       (p[0xb]!=0x4c))
    {
        j=AdjustJ(p[3]|p[4]<<8,loadaddr);
        if( !CheckJ(j,fsiz) )
        {
            if((*(unsigned short int*)(p+j)==0x03A9) &&(p[j+2]==0x8d))
            {
                k=p[j+3];
                j=AdjustJ(p[0x9]|p[0xa]<<8,loadaddr);
                if( !CheckJ(j,fsiz) )
                {
                    if((p[j+0]==0xad) &&
                       (p[j+1]==k   ) &&
                       (p[j+3]==0xf0) &&
                       (p[j+8]==0x4c))
                    {
                        initaddr=loadaddr+0;
                        playaddr=loadaddr+6;
                        strcpy(ids,"Prosonix");strcat(ids," v3");
                        return 1;
                    }
                }
            }
/***** Heathcliff/DigitalArts v2 1006/1000 ***********************************/
            if(((*(unsigned int*)(p+j+0   )&0x00ff00ff)==0x00F000A9) &&
               ((*(unsigned int*)(p+j+0x04)&0x00ffffff)==0x002000a2) &&
               ((*(unsigned int*)(p+j+0x09)&0x00ffffff)==0x002007a2)
              )
            {
                initaddr=loadaddr+6;
                playaddr=loadaddr+0;
                strcpy(ids,"Heathcliff");strcat(ids," v2");
                return 1;
            }
        }
    }
    return 0;
}
/***** Arne/AFL 1000/1009 ****************************************************/
int Chk_ArneAFL(void)
{
    if(fsiz<0x400) return 0;
    if((p[0x2]==0x4c) &&
       (p[0x5]==0x4c) &&
       (p[0x8]==0x4c) &&
       (p[0xb]==0x4c))
    {
        j=AdjustJ(p[3]|p[4]<<8,loadaddr);
        if( !CheckJ(j,fsiz) )
        {
            if(*(unsigned int*)(p+j)==0x40093F29)
            {
                j=AdjustJ(p[0xc]|p[0xd]<<8,loadaddr);
                if( !CheckJ(j,fsiz) )
                {
                    if((p[j+0]==0x2c) &&
                       (p[j+3]==0x30) &&
                       (p[j+5]==0x70) &&
                       (p[j+7]==0xa9))
                    {
                        initaddr=loadaddr+0;
                        playaddr=loadaddr+9;
                        strcpy(ids,"Arne/AFL");
                        return 1;
                    }
                }
            }
        }
    }
    return 0;
}
/***** Arne/SoundMaker v4 1000/1006 or 1020/1026 *****************************/
int Chk_ArneSndMk(void)
{
    if(fsiz<0x400) return 0;
    i=0;
    for(k=0;k<=0x20;k+=0x20)
    {
        if((p[2+k]==0x4c) &&
           (p[5+k]!=0x4c) &&
           (p[8+k]==0x4c) )
        {
            j=AdjustJ( p[9+k]|p[10+k]<<8,loadaddr);
            if( CheckJ(j,fsiz) )
            {
                break;
            }
            if((p[j  ]==0xad) &&
               (*(unsigned int*)(p+j+3)==0x60F001C9))
            {
                initaddr=loadaddr+k+0;
                playaddr=loadaddr+k+6;
                strcpy(ids,"SoundMaker");strcat(ids," v4/Arne");
                i=1;
                break;
            }
        }
    }
    return i;
}
/***** Digitalizer 2.x by Olav/PD 1003/1006 (normal version is 1000/1003) ****/
int Chk_Digitalizer(void)
{
    if(fsiz<0x200) return 0;
    if((p[2]==0x4c) &&
       (p[5]==0x4c) &&
       (p[8]==0x20) &&
       (*(unsigned int*)(p+0x0B)==0x10033DCE) &&
       (*(unsigned int*)(p+0x1B)==0xADFAD0CA))
    {
        initaddr=loadaddr+3;
        playaddr=loadaddr+6;
        strcpy(ids,"Digitalizer 2.x");
        return 1;
    }
    return 0;
}
/***** Soundmon c000/c020 + patch ********************************************/
int Chk_Soundmon(void)
{
    if((fsiz+loadaddr>0xcb00) &&
       (fsiz>0x2b00) &&
       (loadaddr<=0xa000) )
    {
        if((*(unsigned int*)(p+0xc000-loadaddr+2)==0x4cc0124c) &&
           (*(unsigned int*)(p+0xc020-loadaddr+2)==0xC58D01A5))
        {
            if( (*(unsigned int*)(p+0xc029-loadaddr+2)==0xADCBE120) )
            {
                initaddr=0xce30;
                playaddr=0;
                psidh[0x00]='R';
                psidh[0x78]=8; // freepages
                psidh[0x79]=(loadaddr>>8)-8;
                sprintf(ids,"DUSAT/RockMon%s","3h");
            }
            else if( (*(unsigned int*)(p+0xc029-loadaddr+2)==0xAD80a020) )
            {
                initaddr=0xc000;
                playaddr=0;
                psidh[0x00]='R';
                psidh[0x78]=8; // freepages
                psidh[0x79]=(loadaddr>>8)-8;
                j=initaddr-loadaddr+2;
                memmove(p+j,aPatchRckmon,sizeof(aPatchRckmon));
                sprintf(ids,"DUSAT/RockMon%s","2");
            }
            else
            {
                initaddr=0xc000;
                playaddr=0xc020;
                j=initaddr-loadaddr+2;
                memmove(p+j,aPatchSndmon,sizeof(aPatchSndmon));
                p[0xc031-loadaddr+2]=0x60;
                psidh[0x15]=1; // CIA timing, not always needed
                psidh[0x78]=8; // freepages
                psidh[0x79]=(loadaddr>>8)-8;
                strcpy(ids,"SoundMonitor");
            }
            return 1;
        }
        if((*(unsigned int*)(p+0xc000-loadaddr+2)==0x4cc0124c) &&
           (*(unsigned int*)(p+0xc01d-loadaddr+2)==0x0E8E00a2))
        {
            if((*(unsigned int*)(p+0x9fd0-loadaddr+2)==0x018536a9) &&
               (*(unsigned int*)(p+0x9fdb-loadaddr+2)==0x8D9FA99F) )
            {
                initaddr=0x9fd0;
                playaddr=0;
                psidh[0x00]='R';
                psidh[0x78]=8; // freepages
                psidh[0x79]=(loadaddr>>8)-8;
                j=0x9fe1-loadaddr+2;
                p[j++]=0x20; // some have this nopped, restored.
                p[j++]=0x12;
                p[j++]=0xc0;
                sprintf(ids,"DUSAT/RockMon%s","4");
                return 1;
            }
            if((*(unsigned int*)(p+0x9f00-loadaddr+2)==0x8D02C0AD) &&
               (*(unsigned int*)(p+0x9f04-loadaddr+2)==0x75209F0A) )
            {
                initaddr=0xc000;
                playaddr=0;
                j=initaddr-loadaddr+2;
                memmove(p+j,aPatchRckmon,sizeof(aPatchRckmon));
                psidh[0x00]='R';
                psidh[0x78]=8; // freepages
                psidh[0x79]=(loadaddr>>8)-8;
                sprintf(ids,"DUSAT/RockMon%s","3");
                return 1;
            }
        }
        if((*(unsigned int*)(p+0xc000-loadaddr+2)==0x4cc0124c) &&
           (*(unsigned int*)(p+0xc020-loadaddr+2)==0x4CA90295))
        {
            initaddr=0xc000;
            playaddr=0;
            j=initaddr-loadaddr+2;
            memmove(p+j,aPatchRckmon,sizeof(aPatchRckmon));
            psidh[0x00]='R';
            psidh[0x78]=8; // freepages
            psidh[0x79]=(loadaddr>>8)-8;
            sprintf(ids,"DUSAT/RockMon%s","5");
            return 1;
        }
        if((*(unsigned int*)(p+0xc000-loadaddr+2)==0x4cc0124c) &&
           (*(unsigned int*)(p+0xc01d-loadaddr+2)==0x589B0020) &&
           (*(unsigned int*)(p+0xc02c-loadaddr+2)==0xAD9BA020))
        {
            initaddr=0xc000;
            playaddr=0;
            j=initaddr-loadaddr+2;
            memmove(p+j,aPatchRckmon,sizeof(aPatchRckmon));
            psidh[0x00]='R';
            psidh[0x78]=8; // freepages
            psidh[0x79]=(loadaddr>>8)-8;
            strcpy(ids,"MusicMaster 1.3/BB");
            return 1;
        }
        if((*(unsigned int*)(p+0xc000-loadaddr+2)==0x4cc0124c) &&
           (*(unsigned int*)(p+0xc01d-loadaddr+2)==0x589B0020) &&
           (*(unsigned int*)(p+0xc02c-loadaddr+2)==0xadc47820))
        {
            initaddr=0xc000;
            playaddr=0;
            j=initaddr-loadaddr+2;
            memmove(p+j,aPatchRckmon,sizeof(aPatchRckmon));
            psidh[0x00]='R';
            psidh[0x78]=8; // freepages
            psidh[0x79]=(loadaddr>>8)-8;
            strcpy(ids,"BeatBox/KarlXII");
            return 1;
        }
    }
    return 0;
}
/***** AMP 2.x 157e/14ce->1000/1003 ******************************************/
int Chk_AMP2(void)
{
    if(fsiz<0x600) return 0;
    if((*(unsigned int*)(p+0x0dc)==0x5F4B3827) &&
       (*(unsigned int*)(p+0x1A3)==0x5EDE04F0) &&
       (*(unsigned int*)(p+0x1e8)==0x4a4a4a4a) &&
       (*(unsigned int*)(p+0x224)==0x0a0a0a0a))
    {
        /* found mixed cases:
        internalplayer/init/play
        init/play/internalplayer
        init/play only
        Better replace the correct ones at 1000/1003
        fix: there are versions using init=$1568 others $157e
        */
        j=0;
        if((p[2+0x568]==0xad) &&
           (p[2+0x569]==0x09))
        {
            j=0x68;
        }
        else
        if ((p[2+0x57e]==0xa5) &&
            (p[2+0x588]==0xad) &&
            (p[2+0x589]==0x09))
        {
            j=0x7e;
        }
        if(j)
        {
            p[2]=0x4c;
            p[3]=j;
            p[4]=(loadaddr>>8)+5;
            p[5]=0x4c;
            p[6]=0xce;
            p[7]=(loadaddr>>8)+4;
            strcpy(ids,"AMP 2.x");
            return 1;
        }
    }
    return 0;
}
/***** FC 3.x ****************************************************************/
int Chk_FC3x(void)
{
    if(fsiz<0x200) return 0;
    if((*(unsigned int*)(p+0x08a)==0x7AA200A9) &&
       (*(unsigned int*)(p+0x0af)==0x8DF110CA) &&
       (*(unsigned int*)(p+0x15e)==0x16D0FFC9) &&
       (p[0x104]==0xAD))
    {
        playaddr=loadaddr+6;
        initaddr=loadaddr;
        if(p[0x10a]==0x07)
        {
            initaddr=loadaddr-2;
            extrabytes[0]=initaddr&0xff;
            extrabytes[1]=initaddr>>8;
            extra=2;
            p[0]=0xa9;
            p[1]=0x02;
        }
        /* fix pointers, found wrong ones */
        j=2;
        p[j++]=0x4c;
        p[j++]=0xb4;
        p[j++]=loadaddr>>8;
        j=8;
        p[j++]=0x4c;
        p[j++]=0x02;
        p[j++]=(loadaddr>>8)+1;
        strcpy(ids,"FutureComposer");
        strcat(ids," 3.x");
        return 1;
    }
    return 0;
}
/***** Deenen JTS/TC 110a/112c (patch at $1000) ******************************/
int Chk_MoN_JTS(void)
{
    if(fsiz<0x200) return 0;
    if((p[0x05]==0x4c) &&
       (p[0x06]==0x2c) &&
       (*(unsigned int*)(p+0xe2)==0x70A200A9)&&
       (*(unsigned int*)(p+0xe9)==0xA9FA10CA) )
    {
        initaddr=loadaddr+0;
        playaddr=loadaddr+3;
        p[2]=0x4c;
        p[3]=0x0a;
        p[4]=(loadaddr>>8)+1;
        strcpy(ids,"MoN/JTS");
        return 1;
    }
    return 0;
}
/***** 3 JMPs ****************************************************************/
int Chk_3JMPs2(void)
{
    if(fsiz<0x200) return 0;
    if((p[2]==0x4c) &&
       (p[5]==0x4c) &&
       (p[8]==0x4c))
    {
        /* SIDduzzit 2.07: TAX+1000/1003 *************************************/
        j=AdjustJ( p[6]|p[7]<<8,loadaddr);
        if( !CheckJ(j,fsiz) )
        {
            if((p[j+0x00]==0xa2) &&
               (p[j+0x02]==0x8e) &&
               (p[j+0x05]==0xbd) &&
               (*(unsigned int*)(p+j+0x30)==0xF0F07F29))
            {
                j=AdjustJ(p[3]|p[4]<<8,loadaddr);
                if( !CheckJ(j,fsiz) )
                {
                	if(p[j]!=0xaa)
                    {
                        initaddr=loadaddr-1;
                        extrabytes[0]=initaddr&0xff;
                        extra=1;
                        p[0]=initaddr>>8;
                        p[1]=0xaa;
                    }
                    sprintf(ids,"SidDuzzIt %s","2.07");
                    return 1;
                }
            }
        }
        j=AdjustJ( p[9]|p[0xa]<<8,loadaddr);
        if( !CheckJ(j,fsiz) )
        {
        /* Zardax 1000/1006 **************************************************/
            if((p[j+0x00]==0xad) &&
               (*(unsigned int*)(p+j+0x03)==0xCE6001F0) &&
               (*(unsigned int*)(p+j+0x0a)==0x2002A209))
            {
                initaddr=loadaddr;
                playaddr=loadaddr+6;
                strcpy(ids,"Zardax");strcat(ids," v1");
                return 1;
            }
            if((p[j+0x00]==0xad) &&
               (p[j-0x01]==0x60) &&
               (p[j+0x08]==0x8d) &&
               (p[j+0x0b]==0xa5) &&
               (*(unsigned int*)(p+j+0x03)==0xa56001F0))
            {
                initaddr=loadaddr;
                playaddr=loadaddr+6;
                strcpy(ids,"Zardax");strcat(ids," v2");
                return 1;
            }
        /* Deenen RWE Intro/TC 1000/1006 *************************************/
            if((p[j+0x00]==0xad) &&
               (p[j-0x01]==0x60) &&
               (*(unsigned int*)(p+j+0x03)==0x07f002c9) &&
               (*(unsigned int*)(p+j+0x08)==0x4c04d001))
            {
                initaddr=loadaddr;
                playaddr=loadaddr+6;
                strcpy(ids,"MoN/RWE");
                return 1;
            }
        /* Laxity v4 1000/1006 ***********************************************/
            if((p[j+0x00]==0xad) &&
               (p[j-0x01]==0x60) &&
               (p[j-0x0f]==0x8d) &&
               (p[j-0x3e]==0xa2) &&
               (*(unsigned int*)(p+j+0x03)==0xa26001d0))
            {
                initaddr=loadaddr;
                playaddr=loadaddr+6;
                p[2]=0x4c;
                i=(j-0x3e -2 + loadaddr);
                p[3]=i&0xff;
                p[4]=i>>8;
                strcpy(ids,"Laxity");strcat(ids," v4");
                return 1;
            }
        /* Roland Hermans special case 1006/1000 *****************************/
            if( (p[j+0x03]==0x8d) &&
                (p[j+0x12]==0x8d) &&
                (*(unsigned int*)(p+j+0x06)==0x690a0a0a) &&
                (*(unsigned int*)(p+j+0x28)==0xA9D4178D))
            {
                initaddr=loadaddr+6;
                playaddr=loadaddr;
                strcpy(ids,"Roland Hermans");
                return 1;
            }
        }
        /* SIDduzzit 0.98: TAX+1000/1003 *************************************/
        j=AdjustJ( p[3]|p[4]<<8,loadaddr);
        if( !CheckJ(j,fsiz) )
        {
            if((p[j+0x00]==0xbd) &&
               (p[j+0x03]==0x8d) &&
               (p[j+0x06]==0x8d) &&
               (p[j+0x09]==0xbd) )
            {
                initaddr=loadaddr-1;
                extrabytes[0]=initaddr&0xff;
                extra=1;
                p[0]=initaddr>>8;
                p[1]=0xaa;
                sprintf(ids,"SidDuzzIt %s","0.98");
                return 1;
            }
        /* Laxity v1 1000/1006 ***********************************************/
            if((*(unsigned int*)(p+j+0x00)==0xA98A00A2) &&
               (*(unsigned int*)(p+j+0x1b)==0xE49003E0))
            {
                initaddr=loadaddr+0;
                playaddr=loadaddr+6;
                strcpy(ids,"Laxity");strcat(ids," v1");
                return 1;
            }
        /* Deenen special case 1006/1000 *************************************/
            if(((*(unsigned int*)(p+j+0x00)&0xffff00ff)==0x013000A9)&&
               (p[j+0x04]==0x60)&&
               (p[j+0x05]==0xad)&&
               (p[j+0x08]==0xf0))
            {
                initaddr=loadaddr+6;
                playaddr=loadaddr+0;
                strcpy(ids,"Deenen");
                return 1;
            }
        }
        /* JO v1, variable 3/4 jmps ******************************************/
        for(i=2,k=0;i<=2+(4*3);i+=3)
        {
            if(p[i]==0x4c)
            {
                j=AdjustJ( p[i+1]|p[i+2]<<8,loadaddr);
                if( CheckJ(j,fsiz) )
                {
                    continue;
                }
                if( (p[j+0x00]==0xbd) &&
                    (p[j+0x03]==0x8d) &&
                    (p[j+0x06]==0xbd) &&
                    (p[j+0x09]==0x8d) )
                {
                    k|=1;
                    initaddr=loadaddr+i-2;
                }
                else if( (p[j+0x00]==0xa9) &&
                         (p[j+0x02]==0xd0) &&
                         (p[j+0x03]==0x01) &&
                         (p[j+0x04]==0x60) )
                {
                    k|=2;
                    playaddr=loadaddr+i-2;
                }
            }
        }
        if(k!=3)
        {
            initaddr=loadaddr;
            playaddr=initaddr+3;
        }
        else
        {
            /* add TAX */
            if(initaddr==loadaddr)
            {
                initaddr--;
                extrabytes[0]=initaddr&0xff;
                extra=1;
                p[0]=initaddr>>8;
                p[1]=0xaa;
            }
            else
            {
                extra=4;
                extrabytes[0]=(loadaddr-extra)&0xff;
                extrabytes[1]=(loadaddr-extra)>>8;
                extrabytes[2]=0xaa;
                extrabytes[3]=0x4c;
                p[0]=initaddr&0xff;
                p[1]=initaddr>>8;
                initaddr=loadaddr-extra;
            }
            strcpy(ids,"JO/Vibrants");strcat(ids," v1");
            return 1;
        }
    }
    return 0;
}
/***** JO v2, variable 1/3 JMPs but 1st if present is IRQ install ************/
int Chk_JOv2(void)
{
    if(fsiz<0x200) return 0;
    for(i=2,k=0;i<=2+(2*3);i+=3)
    {
        if(p[i]==0x4c)
        {
            j=AdjustJ( p[i+1]|p[i+2]<<8,loadaddr);
            if( CheckJ(j,fsiz) )
            {
                continue;
            }
            if( (p[j+0x00]==0x8d) &&
                (p[j+0x03]==0x8d) &&
                (*(unsigned int*)(p+j+0x06)==0xA9A80A0A))
            {
                k|=1;
                initaddr=loadaddr+i-2;
                break;
            }
            else if((p[j+0x00]==0x8d) &&
                    (*(unsigned int*)(p+j+0x03)==0xA9A80A0A))
            {
                k|=1;
                initaddr=loadaddr+i-2;
                break;
            }
        }
    }
    if( k )
    {
        for(j=0;j<0x10;j++)
        {
            if( (p[i+j+0x03]==0xad) &&
                (p[i+j+0x06]==0xc9) &&
                (p[i+j+0x07]==0x01) &&
                (p[i+j+0x08]==0xf0) &&
                (p[i+j+0x0a]==0xc9) )
            {
                k|=2;
                playaddr=initaddr+3;
                break;
            }
        }
    }
    if(k!=3)
    {
        initaddr=loadaddr;
        playaddr=initaddr+3;
    }
    else
    {
        strcpy(ids,"JO/Vibrants");strcat(ids," v2");
        return 1;
    }
    return 0;
}
/***** 2 JMPs ****************************************************************/
int Chk_2JMPs(void)
{
    if(fsiz<0x200) return 0;
    if((p[2]==0x4c) &&
       (p[5]==0x4c) )
    {
        j=AdjustJ( p[6]|p[7]<<8,loadaddr);
        if( !CheckJ(j,fsiz) )
        {
        /* XTracker_V4.x 1003/1000 *******************************************/
            if((p[j+0x00]==0xaa) &&
               (p[j+0x01]==0xbd) &&
               (p[j+0x04]==0x8d) )
            {
                initaddr=loadaddr+3;
                playaddr=loadaddr+0;
                sprintf(ids,"XTracker_V4.1%s/LoS","c");
                return 1;
            }
        /* Nordicbeat: TAX+1000/1003 ****************************************/
            if((p[j+0x00]==0xa2) &&
               (p[j+0x01]==0x00) &&
               (p[j+0x02]==0xce) &&
               (p[j+0x05]==0x30) &&
               (p[j+0x06]==0x09) &&
               (p[j+0x07]==0x20) &&
               (p[j+0x0a]==0x20) &&
               (p[j+0x0d]==0x4c) )
            {
                initaddr=loadaddr+6;
                playaddr=loadaddr+3;
                k=8;
                p[k++]=0xaa;
                p[k++]=0x4c;
                p[k++]=loadaddr&0xff;
                p[k++]=loadaddr>>8;
                strcpy(ids,"NordicBeat");
                return 1;
            }
        /* ICC/The Voice $1003/$1000 ****************************************/
            if((*(unsigned int*)(p+j+0x00)==0x00A918A2)&&
               (*(unsigned int*)(p+j+0x04)==0xCAD4009D)&&
               (*(unsigned int*)(p+j+0x43)==0x06F0F029)&&
               (*(unsigned int*)(p+j+0x53)==0x06F0F029)&&
               (*(unsigned int*)(p+j+0xa9)==0x4A4A4A4A))
            {
                initaddr=loadaddr+3;
                playaddr=loadaddr+0;
                strcpy(ids,"ICC/The Voice");
                return 1;
            }
        }
        j=AdjustJ( p[3]|p[4]<<8,loadaddr);
        if( !CheckJ(j,fsiz) )
        {
        /* XTracker_V4.x 1003/1000 *******************************************/
            if((p[j+0x00]==0xa0) &&
               (p[j+0x01]==0x00) &&
               (p[j+0x02]==0xf0) &&
               (p[j+0x04]==0x60) )
            {
                initaddr=loadaddr+3;
                playaddr=loadaddr+0;
                sprintf(ids,"XTracker_V4.1%s/LoS","a");
                return 1;
            }
            if((p[j+0x00]==0xce) &&
               (p[j+0x02]==(loadaddr>>8)) &&
               (p[j+0x03]==0x10) )
            {
                initaddr=loadaddr+3;
                playaddr=loadaddr+0;
                sprintf(ids,"XTracker_V4.1%s/LoS","b");
                return 1;
            }
            if((p[j+0x00]==0x2c) &&
               (p[j+0x02]==(loadaddr>>8)) &&
               (p[j+0x03]==0x30) &&
               (*(unsigned int*)(p+j+5)==0xA2600170))
            {
                initaddr=loadaddr+3;
                playaddr=loadaddr+0;
                strcpy(ids,"LordsOfSonics/MS");
                return 1;
            }
        /* Guy Shavitt 1000/1006 *********************************************/
            if((p[j+0x00]==0xa2) &&
               (p[j+0x01]==0x00) &&
               (p[0x08  ]==0xad) &&
               (p[0x0b  ]==0x10))
            {
                initaddr=loadaddr+0;
                playaddr=loadaddr+6;
                strcpy(ids,"Guy Shavitt");
                return 1;
            }
        /* Audial Arts: TAY+1000/1003 ****************************************/
            if((*(unsigned int*)(p+j+0x00)==0x00A978A2) &&
               (*(unsigned int*)(p+j+0x07)==0x20FA10CA) &&
               (*(unsigned int*)(p+j+0x21)==0xA9F710CA) &&
               (p[j+0x0d ]==0xb9) )
            {
                initaddr=loadaddr-1;
                extrabytes[0]=initaddr&0xff;
                extra=1;
                p[0]=initaddr>>8;
                p[1]=0xa8;
                strcpy(ids,"Audial Arts");
                return 1;
            }
        /* TFMX/MasterComposer 1003/1000 *************************************/
            if((*(unsigned int*)(p+j-0x03)==0xAD60FA10) &&
               (*(unsigned int*)(p+j+0x03)==0x0EAE12F0) &&
               (*(unsigned int*)(p+j+0x0e)==0x8EE8FA10) )
            {
                initaddr=loadaddr+3;
                playaddr=loadaddr+0;
                strcpy(ids,"TFMX/MasterComposer");
                return 1;
            }
        /* SIDduzzit 2.1: TAX+1000/1003 **************************************/
            if((p[j+0x00]==0xbd) &&
               (p[j+0x03]==0x8d) &&
               (p[j+0x06]==0xa9) &&
               (p[j+0x08]==0x8d) &&
               ((p[j+0x18]==0x4a)||(p[j+0x18]==0xa9))
              )
            {
                initaddr=loadaddr-1;
                extrabytes[0]=initaddr&0xff;
                extra=1;
                p[0]=initaddr>>8;
                p[1]=0xaa;
                sprintf(ids,"SidDuzzIt %s","2.1");
                return 1;
            }
        }
        /* Laxity v3 1000/1006 ***********************************************/
        if((p[8]==0x2c) &&
           (*(unsigned int*)(p+0xb)==0xA9600130) )
        {
            initaddr=loadaddr+0+k;
            playaddr=loadaddr+6+k;
            strcpy(ids,"Laxity");strcat(ids," v3");
            return 1;
        }
    }
    return 0;
}
/***** Laxity v2 1000/1006 ***************************************************/
int Chk_LaxityV2(void)
{
    if(fsiz<0x200) return 0;
    for(k=0;k<=0x100;k+=0x100)
    {
        if((p[2+k]==0x4c) &&
           (p[5+k]==0x4c) &&
           (*(unsigned int*)(p+0xa+k)==0x2CD4188D) )
        {
            initaddr=loadaddr+0+k;
            playaddr=loadaddr+6+k;
            strcpy(ids,"Laxity");strcat(ids," v2");
            return 1;
        }
    }
    return 0;
}
/***** Rob Hubbard 1000/1012 *************************************************/
int Chk_HubbardV2(void)
{
    if(fsiz<0x200) return 0;
    i=0;
    if((p[0x02]==0x4c) &&
       (p[0x05]==0x4c) &&
       (p[0x08]==0x4c) &&
       (p[0x0b]==0x4c) &&
       (p[0x0e]==0x4c) &&
       (p[0x11]==0x4c) )
    {
        for(j=0x14;j<0x30;j++)
        {
            if((p[0+j]==0x2c) &&
               (p[3+j]==0x30) &&
               (p[5+j]==0x50))
            {
                initaddr=loadaddr+0;
                playaddr=loadaddr+0x12;
                strcpy(ids,"Hubbard");strcat(ids," v2");
                i=1;
                break;
            }
        }
    }
    return i;
}
/***** Rob Hubbard 1000/1006 *************************************************/
int Chk_HubbardV1(void)
{
    if(fsiz<0x200) return 0;
    i=0;
    for(k=0;k<=0x100;k++)
    {
        if((p[0x02+k]==0x4c) &&
           (p[0x05+k]==0x4c) )
        {
            for(j=k+8;j<k+0x20;j++)
            {
                if(p[0+j]==0x60)
                    break;
                if((p[0+j]==0x2c) &&
                   (p[3+j]==0x30) &&
                   (p[5+j]==0x50))
                {
                    initaddr=loadaddr+0+k;
                    playaddr=loadaddr+6+k;
                    strcpy(ids,"Hubbard");strcat(ids," v1");
                    i=1;
                    break;
                }
            }
        }
    }
    return i;
}
/***** Rob Hubbard 155f/103f (ACE_II hacks) **********************************/
int Chk_HubbardV3(void)
{
    if(fsiz<0x600) return 0;
    if((p[0x41]==0xa9) &&
       (p[0x46]==0x2c) &&
       (p[0x561]==0xa9) &&
       (p[0x562]==0x40) &&
       (p[0x566]==0x60) &&
       (*(unsigned int*)(p+0x49)==0x40502A30)&&
       (*(unsigned int*)(p+0x55)==0x9DD40499))
    {
        initaddr=loadaddr+0x55f;
        playaddr=loadaddr+0x3f;
        strcpy(ids,"Hubbard");strcat(ids," v3");
        return 1;
    }
    return 0;
}
/***** Rob Hubbard 1xxx/1xxx (simpler version of v5) *************************/
int Chk_HubbardV4(void)
{
    if(fsiz<0x700) return 0;
    i=0;
    for(k=0;k<=0x100;k++)
    {
        if((p[0x00 + k]==0xa2) &&
           (p[0x01 + k]==0x02) &&
           (p[0x02 + k]==0xce) &&
           (p[0x05 + k]==0x10) &&
           (p[0x06 + k]==0x06) &&
           (p[0x07 + k]==0xad) &&
           (p[0x2b + k]==0x30) &&
           (p[0x2d + k]==0x4c) &&
           (p[0x30 + k]==0x4c) )
        {
            i=k;
            break;
        }
    }
    if(i>0)
    {
        // play addr
        j=AdjustJ( p[k+3]|p[k+4]<<8,loadaddr);
        if( !CheckJ(j,fsiz) )
        {
            j-=0xf0;
            for(k=0;k<=0x100;k++)
            {
                if((p[j+k+0x00]==0xad)&&
                   (p[j+k+0x03]==0xd0)&&
                   (((p[j+k+0x05]==0xee)&&(p[j+k+0x08]==0xee))||
                    ((p[j+k+0x05]==0xe6)&&(p[j+k+0x07]==0xe6)))
                    )
                {
                    playaddr=loadaddr+j+k-2;
                    break;
                }
            }
            // init
            for(   ;k<=0x100;k++)
            {
                if((p[j+k+0x00]==0xaa)&&
                   (p[j+k+0x01]==0xbd)&&
                   (p[j+k+0x06]==0xbd)&&
                   (p[j+k+0x04]==0x85)&&
                   (p[j+k+0x09]==0x85)&&
                   (p[j+k+0x18]==0xa2))
                {
                    initaddr=loadaddr+j+k-2;
                    break;
                }
            }
            if(k==0x101)
            {
                initaddr=loadaddr;
                playaddr=initaddr+3;
                return 0;
            }
            else
            {
                if(i>=6)
                {
                    k=2;
                    p[k++]=0x4c;
                    p[k++]=initaddr&0xff;
                    p[k++]=initaddr>>8;
                    p[k++]=0x4c;
                    p[k++]=playaddr&0xff;
                    p[k++]=playaddr>>8;
                    initaddr=loadaddr;
                    playaddr=initaddr+3;
                }
                strcpy(ids,"Hubbard");strcat(ids," v4");
                return 1;
            }
        }
    }
    return 0;
}
/***** Rob Hubbard 1xxx/1xxx (FC probably based on this) *********************/
int Chk_HubbardV5(void)
{
    if(fsiz<0x700) return 0;
    i=0;
    for(k=0;k<=0x100;k++)
    {
        if((p[0x00 + k]==0xa2) &&
           (p[0x01 + k]==0x02) &&
           (p[0x02 + k]==0xce) &&
           (p[0x05 + k]==0x10) &&
           (p[0x06 + k]==0x06) &&
           (p[0x07 + k]==0xad) &&
           (p[0x2e + k]==0x30) &&
           (p[0x30 + k]==0x4c) &&
           (p[0x33 + k]==0x4c) )
        {
            i=k;
            break;
        }
    }
    if(i>0)
    {
        // play addr
        j=AdjustJ( p[k+3]|p[k+4]<<8,loadaddr);
        if( !CheckJ(j,fsiz) )
        {
            j-=0xf0;
            for(k=0;k<=0x100;k++)
            {
                if((p[j+k+0x00]==0xad)&&
                   (p[j+k+0x03]==0xc9)&&
                   (p[j+k+0x07]==0xc9)&&
                   (p[j+k+0x0b]==0xee)&&
                   (p[j+k+0x0e]==0xee)&&
                   (p[j+k+0x11]==0xee)
                    )
                {
                    playaddr=loadaddr+j+k-2;
                    break;
                }
            }
            // init
            for(   ;k<=0x100;k++)
            {
                if((p[j+k+0x00]==0x48)&&
                   (p[j+k+0x01]==0xa9)&&
                   (p[j+k+0x02]==0x01)&&
                   (p[j+k+0x03]==0x8d)&&
                   (p[j+k+0x07]==0xaa)&&
                   (p[j+k+0x0b]==0x85)&&
                   (p[j+k+0x1f]==0xa2))
                {
                    initaddr=loadaddr+j+k-2;
                    break;
                }
            }
            if(k==0x101)
            {
                initaddr=loadaddr;
                playaddr=initaddr+3;
                return 0;
            }
            else
            {
                if(i>=6)
                {
                    k=2;
                    p[k++]=0x4c;
                    p[k++]=initaddr&0xff;
                    p[k++]=initaddr>>8;
                    p[k++]=0x4c;
                    p[k++]=playaddr&0xff;
                    p[k++]=playaddr>>8;
                    initaddr=loadaddr;
                    playaddr=initaddr+3;
                }
                strcpy(ids,"Hubbard");strcat(ids," v5");
                return 1;
            }
        }
    }
    return 0;
}

/***** Mike/LSD 1006/1003 ****************************************************/
int Chk_MikeLSD(void)
{
    if(fsiz<0x200) return 0;
    if((p[0x02]==0x4c) &&
       (p[0x05]==0x4c) &&
       (p[0x08]==0x4c) &&
       (p[0x0b]==0x4c) &&
       (p[0x0e]==0x4c) &&
       (*(unsigned int*)(p+0x15)==0xA90001C9)&&
       (*(unsigned int*)(p+0x61)==0x07E93898))
    {
        initaddr=loadaddr+6;
        playaddr=loadaddr+3;
        strcpy(ids,"Mike/LSD");strcat(ids," v1");
        return 1;
    }
    if((p[0x02]==0x4c) &&
       (p[0x05]==0x4c) &&
       (p[0x08]==0xa9) &&
       (p[0x0b]==0x4c) &&
       (p[0x11]==0x4c) &&
       (*(unsigned int*)(p+0x14)==0xA96080A9)&&
       (*(unsigned int*)(p+0xfe)==0x07E9388A))
    {
        initaddr=loadaddr+6;
        playaddr=loadaddr+3;
        strcpy(ids,"Mike/LSD");strcat(ids," v2");
        return 1;
    }
    return 0;
}
/***** Comptech 1003/1000 ****************************************************/
int Chk_Comptech(void)
{
    if(fsiz<0x200) return 0;
    if((p[2]==0x4c) &&
       (p[5]==0x8d) &&
       (p[8]==0x60) )
    {
        j=AdjustJ(p[3]|p[4]<<8,loadaddr);
        if( !CheckJ(j,fsiz) )
        {
            if((p[j]==0xad) &&
               (*(unsigned int*)(p+j+0x3)==0xF6F0FFC9))
            {
                initaddr=loadaddr+3;
                playaddr=loadaddr+0;
                strcpy(ids,"Comptech 2.x/LoS");
                return 1;
            }
        }
    }
    return 0;
}
/***** SoundMaker v3 & 5_Dimension 1000/1006 *********************************/
int Chk_SoundMaker(void)
{
    if(fsiz<0x200) return 0;
    if((p[2]==0x4c) &&
       (p[5]!=0x4c) &&
       (p[8]==0x4c) )
    {
        j=AdjustJ(p[3]|p[4]<<8,loadaddr);
        if( !CheckJ(j,fsiz) )
        {
            if((p[j  ]==0xaa) &&
               (p[j+1]==0xbd) &&
               (p[j+4]==0x8d) &&
               (p[j+7]==0x8a) )
            {
                initaddr=loadaddr+0;
                playaddr=loadaddr+6;
                strcpy(ids,"SoundMaker");strcat(ids," v3/UA");
                return 1;
            }
        }
    }
    return 0;
}
/***** Electrosound **********************************************************/
int Chk_Electrosound(void)
{
    if(fsiz<0xc00) return 0;
    if((*(unsigned int*)(p+0x02 )==0x05D0B0C9) &&
       (*(unsigned int*)(p+0x06 )==0x154C30A9) &&
       (*(unsigned int*)(p+0x18a)==0x0a0a0a0a))
    {
        memset(p+0xa8a,0,0x278);
        p[0xa64]=0x60;
        p[0xa7d]=0x60;
        p[0xa86]=0x60;
        k=0xb02;
        memmove(p+k,aPatchElcSnd,sizeof(aPatchElcSnd));
        p[0xb05]=(loadaddr>>8)+5;
        p[0xb0d]=(loadaddr>>8)+0xb;
        initaddr=loadaddr+0xb00;
        playaddr=loadaddr+0xa65;
        psidh[0x15]=1; // CIA timing
        strcpy(ids,"Electrosound");
        return 1;
    }
    return 0;
}
/***** PollyTracker **********************************************************/
int Chk_PollyTracker(void)
{
    if(fsiz<0x400) return 0;
    if((loadaddr>=0x0800) &&
       (loadaddr<=0x080d) &&
       (*(unsigned int*)(p-loadaddr+2+0x819)==0x8D02A6AD) &&
       (*(unsigned int*)(p-loadaddr+2+0x81d)==0x38A9080C) &&
       (*(unsigned int*)(p-loadaddr+2+0x89f)==0x4a4a4a4a))
    {
        psidh[0x00]='R';
        initaddr=0x80d;
        playaddr=0;
        psidh[0x78]=4;
        psidh[0x79]=4;
        k=0x80e - loadaddr+2;
        memmove(p+k,aPatchPolly1,sizeof(aPatchPolly1));
        k=0x873 - loadaddr+2;
        memmove(p+k,aPatchPolly2,sizeof(aPatchPolly2));
        k=0x8b7 - loadaddr+2;
        p[k++]=0xa9;
        k=0x8c8 - loadaddr+2;
        memset(p+k,0xea,3);
        k=0x9a4 - loadaddr+2;
        memset(p+k,0xea,3);
        strcpy(ids,"PollyTracker");
        return 1;
    }
    return 0;
}
/***** Master Composer *******************************************************/
int Chk_MasterComp(void)
{
    if(fsiz<0x400) return 0;
    j = -1;
    for(k=0;k<fsiz-0x300;k++)
    {
        if((*(unsigned int*)(p+k+0x02)==0x29D404AD) &&
           (*(unsigned int*)(p+k+0x06)==0xD4048DFE) &&
           (*(unsigned int*)(p+k+0x12)==0x29D412AD) &&
           (*(unsigned int*)(p+k+0x16)==0xD4048DFE) &&
           (*(unsigned short int*)(p+k+0x9c)==(unsigned short int)(k+loadaddr))) /* JMP to k */
        {
            j=k;
            break;
        }
    }
    if(j != -1)
    {
        p+=j;
        fsiz-=j;
        loadaddr+=j;
        initaddr=(loadaddr - 0x0d);
        playaddr=(loadaddr - 0x06);
        extrabytes[0]=initaddr&0xff;
        extrabytes[1]=initaddr>>8;
        memmove(extrabytes+2,aPatchMastCm,sizeof(aPatchMastCm));
        extrabytes[5]=(loadaddr - 0x05)&0xff;
        extrabytes[6]=(loadaddr - 0x05)>>8;
        p[0]=0x60;
        p[1]=0x00;
        extra=13;
        j=0;
        psidh[0x15]=1; // CIA timing
        k=j+0x1a;
        memset(p+k,0x60,3);
        k=j+0x36;
        memset(p+k,0x60,3);
        k=j+0x85;
        p[k]=0xea;
        k=j+0x90;
        memset(p+k,0xea,0x0b);
        p[k++]=0xa9;
        p[k++]=0x00;
        p[k++]=0x8d;
        p[k++]=(loadaddr - 0x05)&0xff;
        p[k++]=(loadaddr - 0x05)>>8;
        k=j+0x24c;
        memset(p+k,0x60,3);
        k=j+0x25a;
        p[k++]=0xea;
        p[k++]=0x4c;
        p[k++]=(loadaddr+0x26b)&0xff;
        p[k++]=(loadaddr+0x26b)>>8;
        k=j+0x265;
        p[k]=0xea;
        k=j+0x289;
        memset(p+k,0xea,0x0c);
        strcpy(ids,"Master Composer");
        return 1;
    }
    return 0;
}
/***** Ubik's music **********************************************************/
int Chk_Ubik(void)
{
    if(fsiz<0x400) return 0;
    j = -1;
    for(k=0x68;k<fsiz-0x300;k++)
    {
        if((p[k]==0xad) &&
           (*(unsigned int*)(p+k+0x03)==0x22D00330) &&
           (*(unsigned int*)(p+k+0x07)==0x7F291860) &&
           (*(unsigned int*)(p+k+0x30)==0xA8306918))
        {
            j=k;
            break;
        }
    }
    if(j != -1)
    {
        k=j-0x66;
        initaddr=k+loadaddr-2;
        playaddr=initaddr+3;
        memset(p+k,0,0x66);
        memmove(p+k,aPatchUbiksM,sizeof(aPatchUbiksM));
        k++;
        p[k++]=(playaddr+3)&0xff;
        p[k++]=(playaddr+3)>>8;
        k++;
        p[k++]=(playaddr+22)&0xff;
        p[k++]=(playaddr+22)>>8;
        k+=4;
        p[k++]=p[j+1];
        p[k++]=p[j+2];
        k+=21;
        p[k++]=(j+loadaddr-2)&0xff;
        p[k++]=(j+loadaddr-2)>>8;
        psidh[0x0f]=9; // there can be subtunes
        strcpy(ids,"Ubik's Music");
        return 1;
    }
    return 0;
}
/***** AMP 1.x variable around $13xx *****************************************/
int Chk_AMP1(void)
{
    if(fsiz<0x600) return 0;
    j = -1;
    for(k=0x300;k<0x400;k++)
    {
        if((*(unsigned int*)(p+k)==0x0BB015E0) &&
           (p[k+0x4]==0xad) &&
           (p[k+0x7]==0x3d) &&
           (p[k+0xa]==0xf0) )
        {
            playaddr=k;
            j=8;
            while(j>0&&p[playaddr]!=0x60)
            {
                playaddr--;
                j--;
            }
            if(j>0)
            {
                j = -1;
                for(;k<0x400;k++)
                {
                    if((p[k  ]==0x60) &&
                       (p[k+1]==0xa9))
                    {
                        j=k+1;
                        break;
                    }
                }
                if(j>0)
                {
                    playaddr++;
                    playaddr+=loadaddr-2;
                    initaddr=j;
                    initaddr+=loadaddr-2;
                }
                else
                {
                    playaddr=initaddr+3;
                }
            }
            break;
        }
    }
    if(j>0)
    {
        strcpy(ids,"AMP 1.x");
        return 1;
    }
    return 0;
}
/***** Boogaloo **************************************************************/
int Chk_Boogaloo(void)
{
    if(fsiz<0x200) return 0;
    if((p[0x2]==0x4c) &&
       (p[0xd]==0xd4) &&
       (*(unsigned int*)(p+0x05)==0x9DAA0029))
    {
        initaddr=loadaddr+3;
        playaddr=loadaddr+0;
        strcpy(ids,"Boogaloo");
        return 1;
    }
    return 0;
}
/***** Bjerregaard: TAX+$1000, variable play around $10xx ********************/
int Chk_Bjerregaard1(void)
{
    if(fsiz<0x200) return 0;
    j = -1;
    if(p[2]==0x4c)
    {
        for(k=0x00;k<0x100;k++)
        {
            if((p[k    ]==0xad) &&
               (*(unsigned int*)(p+k+3)==0xCE600110) &&
               (p[k+0x9]==0x10) )
            {
                j=k;
                break;
            }
        }
    }
    if(j>0)
    {
        initaddr=loadaddr-1;
        extrabytes[0]=initaddr&0xff;
        extra=1;
        p[0]=initaddr>>8;
        p[1]=0xaa;
        j=k+loadaddr-2;
        if(p[5]==0x4c)
        {
            k=p[6]|p[7]<<8;
            if(j!=k)
            {
                playaddr=j;
            }
        }
        else
        {
            playaddr=j;
        }
        strcpy(ids,"Bjerregaard");strcat(ids," v1");
        return 1;
    }
    return 0;
}
/***** Bjerregaard v2: $109b/10a1 ********************************************/
int Chk_Bjerregaard2(void)
{
    if(fsiz<0x200) return 0;
    j = -1;
    for(k=0;k<=0xff;k++)
    {
        if((p[k+0x00]==0x4c) &&
           (p[k+0x03]==0x4c) &&
           (p[k+0x06]==0x4c) &&
           (p[k+0x1b]==0xa9) &&
           (*(unsigned int*)(p+k+0x1d)==0xA26001D0) &&
           (*(unsigned int*)(p+k+0x21)==0xA5DDC602) )
        {
            j=k;
            break;
        }
    }
    if (j>0)
    {
        initaddr=loadaddr+k-2;
        playaddr=initaddr+6;
        strcpy(ids,"Bjerregaard");strcat(ids," v2");
        return 1;
    }
    return 0;
}
/***** Reflextracker *********************************************************/
int Chk_ReflexTrk(void)
{
    if((fsiz+loadaddr > 0xc500) && (fsiz+loadaddr < 0xd000))
    {
        if((*(unsigned int*)(p+0xc000-loadaddr+2)==0x4CC02C4C) &&
           (*(unsigned short int*)(p+0xc004-loadaddr+2)==0xC016) &&
           (*(unsigned int*)(p+0xc00a-loadaddr+2)==0xC02C2001) )
        {
            initaddr=0xc006;
            playaddr=0;
            psidh[0x00]='R';
            strcpy(ids,"ReflexTracker");
            return 1;
        }
    }
    return 0;
}
/***** FAME ******************************************************************/
int Chk_FAME(void)
{
    if(fsiz<0x300) return 0;
    j = -1;
    for(k=0;k<0x80;k++)
    {
        if((p[k+0x00]==0xaa) &&
           (p[k+0x01]==0xbd) &&
           (p[k+0x04]==0x8d) &&
           (p[k+0x35]==0x4c) &&
           (p[k+0x38]==0xa2) &&
           (*(unsigned int*)(p+k+0x07)==0x50850A8A) &&
           (*(unsigned int*)(p+k+0x0b)==0x5065180A))
        {
            j=k;
            initaddr=j+loadaddr-2;
            playaddr=j+loadaddr-2+0x38;
            break;
        }
    }
    if (j>0)
    {
        strcpy(ids,"FAME");strcat(ids," v1");
        return 1;
    }
    j = -1;
    for(k=0;k<0xff;k++)
    {
        if(*(unsigned int*)(p+k+0x00)==0xA959A2A8)
        {
            j=k;
            for(;k<0x200;k++)
            {
                if((*(unsigned int*)(p+k+0x00)== 0x7D1898C8) &&
                   (p[k+0x0e]==0x4c) &&
                   (p[k+0x11]==0x4c) &&
                   (p[k+0x14]==0xa2))
                {
                    initaddr=j+loadaddr-2;
                    playaddr=k+loadaddr-2+0x14;
                    break;
                }
            }
            if(k==0x200)
            {
                j = -1;
            }
            break;
        }
    }
    if (j>0)
    {
        strcpy(ids,"FAME");strcat(ids," v2");
        return 1;
    }
    if((p[0x2]==0x4c) &&
       (p[0x9]==0x8d) &&
       (*(unsigned int*)(p+0x05)==0x00A959A2))
    {
        initaddr=loadaddr+3;
        playaddr=loadaddr+0;
        strcpy(ids,"FAME");strcat(ids," v3");
        return 1;
    }
    return 0;
}
/***** 20CC ******************************************************************/
int Chk_20CC(void)
{
    if(fsiz<0x300) return 0;
    j = -1;
    for(k=0;k<=0xff;k++)
    {
        if((p[k+0x00]==0xa9) &&
           (p[k+0x02]==0x30) &&
           (p[k+0x04]==0xf0) &&
           (p[k+0x0a]==0xb9) &&
           (p[k+0x10]==0xb9) &&
           (p[k+0x0d]==0x8d) &&
           (p[k+0x13]==0x8d) &&
           (*(unsigned int*)(p+k+0x06)==0xa80a0a0a) )
        {
            j=k;
            break;
        }
        if((p[k+0x00]==0xa0) &&
           (p[k+0x02]==0x30) &&
           (p[k+0x04]==0xf0) &&
           (p[k+0x06]==0x88) &&
           (p[k+0x07]==0x98) &&
           (p[k+0x0c]==0xb9) &&
           (*(unsigned int*)(p+k+0x08)==0xa80a0a0a) )
        {
            j=k;
            break;
        }
        if((p[k+0x00]==0xa0) &&
           (p[k+0x02]==0x30) &&
           (p[k+0x04]==0xf0) &&
           (p[k+0x06]==0xA2) &&
           (p[k+0x07]==0x17) &&
           (p[k+0x15]==0x8E) &&
           (p[k+0x22]==0xb9))
        {
            j=k;
            break;
        }
    }
    if (j>0)
    {
        extra=6;
        initaddr=loadaddr-extra;
        playaddr=j+loadaddr-2;
        k=0;
        extrabytes[k++]=initaddr&0xff;
        extrabytes[k++]=initaddr>>8;
        extrabytes[k++]=0xa9;
        extrabytes[k++]=0x01;
        extrabytes[k++]=0x8d;
        extrabytes[k++]=(playaddr+1)&0xff;
        p[0]=(playaddr+1)>>8;
        p[1]=0x60;
        strcpy(ids,"20CC");strcat(ids," v1");
        return 1;
    }
    if((p[2]==0xa4)&&
       (p[8]==0x4c)&&
       (*(unsigned int*)(p+0x04)==0x03F00930) &&
       (*(unsigned int*)(p+0x0c)==0xA260D418) )
    {
        extra=5;
        initaddr=loadaddr-extra;
        playaddr=loadaddr;
        k=0;
        extrabytes[k++]=initaddr&0xff;
        extrabytes[k++]=initaddr>>8;
        extrabytes[k++]=0xa9;
        extrabytes[k++]=0x01;
        extrabytes[k++]=0x85;
        p[0]=p[3];
        p[1]=0x60;
        strcpy(ids,"20CC");strcat(ids," v2");
        return 1;
    }
    return 0;
}
/***** Cybertracker/EXE ******************************************************/
int Chk_CTExe(void)
{
    if((loadaddr == 0x800)&&(fsiz>0x4000)&&
       (*(unsigned int*)(p+0x3ee1)==0x9AFFA278) &&
       (*(unsigned int*)(p+0x4001)==0x4C4A7D4C) &&
       (*(unsigned int*)(p+0x40dc)==0x4a4a4a4a) )
    {
        initaddr=0x53A2;
        playaddr=0x53E2;
        strcpy(ids,"Cybertracker/EXE");
        return 1;
    }
    return 0;
}
/***** System6581 LDA#2+JSR$1000/LDA#1+JSR$1000 ******************************/
int Chk_System6581(void)
{
    if(fsiz<0x200) return 0;
    j = -1;
    if(((*(unsigned int*)(p+0x02)&0x0fffffff)==0x092CF0AA)&&
        (*(unsigned int*)(p+0x17)==0xD4009DAA) &&
        (*(unsigned int*)(p+0x22)==0x8E01A2F5) )
    {
        j = 7;
        strcpy(ids,"System6581");strcat(ids," v1");
    }
    else if((*(unsigned int*)(p+0x02)==0xC930F0A8) &&
            (*(unsigned int*)(p+0x06)==0x4C35D001) &&
           ((*(unsigned int*)(p+0x43)&0xff1fffff)==0xD4009DAA) &&
            (*(unsigned int*)(p+0x4d)==0x3898F5D0) )
    {
        j = 7;
        strcpy(ids,"System6581");strcat(ids," v2");
    }
    if(j>0)
    {
        extra=j;
        initaddr=loadaddr-extra;
        playaddr=loadaddr-2;
        k=0;
        extrabytes[k++]=initaddr&0xff;
        extrabytes[k++]=initaddr>>8;
        extrabytes[k++]=0x18;
        extrabytes[k++]=0x69;
        extrabytes[k++]=0x02;
        extrabytes[k++]=0xd0;
        extrabytes[k++]=0x02;
        p[0]=0xa9;
        p[1]=0x01;
        return 1;
    }
    return 0;
}
/***** Matt Gray: LDA #01 STA $1000/$1002 ************************************/
int Chk_MattGray(void)
{
    if(fsiz<0x200) return 0;
    if((p[0x04]==0xa2)&&
       (p[0x05]==0x00)&&
       (p[0x06]==0x20)&&
       (p[0x13]==0x60)&&
       (p[0x14]==0xad)&&
       (p[0x15]==(loadaddr&0xff))&&
       (p[0x16]==(loadaddr>>8)  )&&
       (p[0x1d]==0xc9)&&
       (p[0x1e]==0xab) )
    {
        extra=6;
        initaddr=loadaddr-extra;
        playaddr=loadaddr+2;
        k=0;
        extrabytes[k++]=initaddr&0xff;
        extrabytes[k++]=initaddr>>8;
        extrabytes[k++]=0xa9;
        extrabytes[k++]=0x01;
        extrabytes[k++]=0x8d;
        extrabytes[k++]=(loadaddr&0xff);
        p[0]=(loadaddr>>8)  ;
        p[1]=0x60;
        strcpy(ids,"Matt Gray");
        return 1;
    }
    return 0;
}
/***** Power Music: LDA #subtune+1 STA $1000/$1001 ***************************/
int Chk_PowerMus(void)
{
    if(fsiz<0x200) return 0;
    if((p[0x03]==0xad)&&
       (p[0x04]==0x00)&&
       (p[0x05]==(loadaddr>>8))&&
       (*(unsigned int*)(p+0x06)==0x01103AF0) &&
       (*(unsigned int*)(p+0x0a)==0x01E93860) )
    {
        extra=7;
        initaddr=loadaddr-extra;
        playaddr=loadaddr+1;
        k=0;
        extrabytes[k++]=initaddr&0xff;
        extrabytes[k++]=initaddr>>8;
        extrabytes[k++]=0x18;
        extrabytes[k++]=0x69;
        extrabytes[k++]=0x01;
        extrabytes[k++]=0x8d;
        extrabytes[k++]=(loadaddr&0xff);
        p[0]=(loadaddr>>8)  ;
        p[1]=0x60;
        strcpy(ids,"Power Music");
        return 1;
    }
    return 0;
}
/***** GRG tiny2:variable entry points ***************************************/
int Chk_GRGTiny2(void)
{
    if(fsiz<0x100) return 0;
    j = 0;
    for(k=0;k<fsiz-0x20;k++)
    {
        if((p[k  ]==0xa2) &&
           (p[k+1]==0x0e) &&
           (p[k+2]==0x86) )
        {
            playaddr=k+loadaddr-2;
            j|=1;
        }
        if((p[k  ]==0xa9) &&
           (p[k+1]==0x60) )
        {
            if(((p[k+2]==0x8d)&&(p[k+5]==0xa2))||
               ((p[k+2]==0x85)&&(p[k+4]==0xa2)))
            {
                initaddr=k+loadaddr-2;
                // there could be a AD 86 02 D0 some bytes before this
                // it's a self mod code to play the tune in ntsc
                for(i=k-4;i>k-0x20;i--)
                {
                    if((*(unsigned int*)(p+i)&0xffffffac)==0xD002A6Ac)
                    {
                        initaddr=i+loadaddr-2;
                        break;
                    }
                }
                j|=2;
            }
        }
        if(j==3)
        {
            break;
        }
    }
    if(j==3)
    {
        strcpy(ids,"GRG Tiny2");
        return 1;
    }
    initaddr=loadaddr;
    playaddr=initaddr+3;
    return 0;
}
/***** Yip Megasound: $1000/$102e or $10xx/$10xx+$2e *************************/
int Chk_Yip(void)
{
    if(fsiz<0x200) return 0;
    j = 0;
    for(k=0;k<0x4f;k++)
    {
        if((p[k     ]==0xa9) &&
           (p[k+0x01]==0x01) &&
           (p[k+0x02]==0x8d) &&
           (p[k+0x28]==0xa9) &&
           (p[k+0x2e]==0xad) &&
           (p[k+0x31]==0xd0) &&
           (p[k+0x32]==0x20) &&
           (p[k+0x33]==0x60)
          )
        {
            j=1;
            initaddr=k+loadaddr-2;
            playaddr=initaddr+0x2e;
            break;
        }
    }
    if(j==1)
    {
        strcpy(ids,"Yip Megasound");
    }
    return j;
}
/***** TFX 1.0 : $1106/$1100 *************************************************/
int Chk_TFX1(void)
{
    if(fsiz<0x200) return 0;
    if((p[0x102]==0x4c)&&
       (p[0x105]==0x4c)&&
       (p[0x10e]==0xa8)&&
       (p[0x10f]==0xb9)&&
       (*(unsigned int*)(p+0x108)==0x8d0a0a0a)
      )
    {
        initaddr=loadaddr+0x106;
        playaddr=loadaddr+0x100;
        strcpy(ids,"TFX 1.0");
        return 1;
    }
    return 0;
}
/***** Griff v1: TAY+$1048/$10e0 *********************************************/
int Chk_Griff1(void)
{
    if(fsiz<0x200) return 0;
    if((*(unsigned int*)(p+0x48 +0x02)==0x00A900A2) &&
       (*(unsigned int*)(p+0x4E +0x02)==0x033C9DD4) &&
       (*(unsigned int*)(p+0x92 +0x02)==0x6003808D) &&
       (*(unsigned int*)(p+0xe0 +0x02)==0xF0039CAD)
      )
    {
        k=2;
        p[k++]=0x4c;
        p[k++]=(loadaddr+0x47)&0xff;
        p[k++]=(loadaddr+0x47)>>8;
        p[k++]=0x4c;
        p[k++]=(loadaddr+0xe0)&0xff;
        p[k++]=(loadaddr+0xe0)>>8;
        p[0x47+2]=0xa8;
        initaddr=loadaddr;
        playaddr=loadaddr+3;
        strcpy(ids,"Griff");
        return 1;
    }
    return 0;
}
/***** Griff v2/LightVoices: TAY+$1000/$1003 *********************************/
int Chk_Griff2(void)
{
    if(fsiz<0x200) return 0;
    if((p[2]==0x4c)&&
       (*(unsigned int*)(p+0x00+0x05)==0xF003A8AD) &&
       (*(unsigned int*)(p+0x04+0x05)==0x50AD6001) &&
       (*(unsigned int*)(p+0x08+0x05)==0xD4188D03) &&
       (*(unsigned int*)(p+0x0C+0x05)==0x8D0351AD)
      )
    {
        initaddr=loadaddr-1;
        extrabytes[0]=initaddr&0xff;
        extra=1;
        p[0]=initaddr>>8;
        p[1]=0xa8;
        strcpy(ids,"Griff");
        strcat(ids,"/LightVoices");
        return 1;
    }
    return 0;
}

/***** Ariston TAX+INX+STX $1000/$1001 ***************************************/
int Chk_Ariston(void)
{
    if(fsiz<0x200) return 0;
    j=-1;

    for(k=0;k<5;k++)
    {
        if((p[k+0x03]==0xad)&&
           ((p[k+0x04]|(p[k+0x05]<<8))==(loadaddr+k))&&
           (p[k+0x06]==0xd0)&&
           (p[k+0x07]==0x09)&&
           (p[k+0x08]==0x8d)&&
           (p[k+0x0b]==0x20)&&
           (p[k+0x0e]==0x4c)&&
           (p[k+0x0d]==p[k+0x10])
          )
        {
            j=k;
            break;
        }
        if((p[k+0x03]==0xad)&&
           ((p[k+0x04]|(p[k+0x05]<<8))==(loadaddr+k))&&
           (p[k+0x06]==0xc9)&&
           (p[k+0x07]==0xff)&&
           (p[k+0x08]==0xf0)&&
           (p[k+0x09]==0x3c)&&
           (p[k+0x17]==0x20)&&
           (p[k+0x1a]==0x4c)&&
           (p[k+0x1c]==p[k+0x19])
          )
        {
            j=k;
            break;
        }
    }
    if(j>=0)
    {
        playaddr=loadaddr+k+1;
        initaddr=loadaddr-6;
        extrabytes[0]=initaddr&0xff;
        extrabytes[1]=initaddr>>8;
        extrabytes[2]=0xaa;
        extrabytes[3]=0xe8;
        extrabytes[4]=0x8e;
        extrabytes[5]=p[k+0x04];
        extra=6;
        p[0]=p[k+0x05];
        p[1]=0x60;
        strcpy(ids,"Ariston");
        return 1;
    }
    return 0;
}
/***** Winterberg $102a/$105a ************************************************/
int Chk_Winterberg(void)
{
    if(fsiz<0x200) return 0;
    j=-1;
    for (i=2;i<0x30;i++)
    {
        if((*(unsigned int*)(p+i)==0x9D8A00A2) &&
           (*(unsigned short int*)(p+0x04+i)==(loadaddr&0xff00)) &&
           (*(unsigned int*)(p+0x06+i)==0xD02AE0E8) &&
           (*(unsigned int*)(p+0x37+i)==0x4C03F000)
          )
        {
            j=i;
            break;
        }
    }
    if(j>=0)
    {
        initaddr=loadaddr+i-2;
        playaddr=initaddr+0x30;
        psidh[0x15]=1; // CIA timing
        j=i+0x10;
        memset(p+j,0xea,10);
        p[0x143+i]=0x60;
        strcpy(ids,"Winterberg");
        return 1;
    }
    return 0;
}

/***** Henrik Jensen $100f/$1015 *********************************************/
int Chk_Jensen(void)
{
    if(fsiz<0x800) return 0;
    k=-1;
    for (i=0;i<0x10;i++)
    {
        if((p[0x0e +i]==0x4c)&&
           (p[0x11 +i]==0x4c)&&
           (p[0x14 +i]==0x4c)&&
           (p[0x17 +i]==0xce)&&
           (p[0x1a +i]==0xce)&&
           (p[0x20 +i]==0xa9)&&
           (*(unsigned int*)(p+0x5b +i)==0x0AD00F30) )
        {
            k=i;
            break;
        }
    }
    if(k>=0)
    {
        initaddr=loadaddr+0x0f+k;
        playaddr=loadaddr+0x15+k;
        strcpy(ids,"Henrik Jensen");
        return 1;
    }
    return 0;
}
/***** MegaVision lda #$80+$1000/$103e ***************************************/
int Chk_MegaVision(void)
{
    if(fsiz<0xb00) return 0;
    if((p[0x0f]==0xad)&&
       (p[0x10]==0x2d)&&
       (*(unsigned int*)(p+0x05c)==0xD40099A8) &&
       (*(unsigned int*)(p+0x060)==0xD018C0C8) &&
       (*(unsigned int*)(p+0x1e0)==0x60E93809) )
    {
    	k=2;
    	p[k++]=0xa9;
    	p[k++]=0x80;
    	p[k++]=0x8d;
    	p[k++]=0x28;
    	p[k++]=loadaddr>>8;
        memset(p+7,0xea,8);
        p[0x26]=0x60;
        p[0x36]=0x60;
        p[0x904]=0x60; // 4c31ea
        psidh[0x15]=1; // CIA timing, not always needed
        initaddr=loadaddr;
        playaddr=loadaddr+0x3e;
        strcpy(ids,"MegaVision");
        return 1;
    }
    return 0;
}

/*****************************************************************************/

typedef int(*Scnptr)(void);

Scnptr ScanFunc[]=
{Chk_FC
,Chk_FCAlt
,Chk_MusAss
,Chk_MusMix
,Chk_GMC
,Chk_Bappalander
,Chk_TrkPl3
,Chk_Groovy
,Chk_Parsec
,Chk_Sosperec
,Chk_SoedeSoft
,Chk_Prosonix1
,Chk_4JMPS
,Chk_Heathcliff
,Chk_3JMPs1
,Chk_ArneAFL
,Chk_ArneSndMk
,Chk_Digitalizer
,Chk_Soundmon
,Chk_AMP2
,Chk_FC3x
,Chk_MoN_JTS
,Chk_3JMPs2
,Chk_JOv2
,Chk_2JMPs
,Chk_LaxityV2
,Chk_HubbardV5
,Chk_HubbardV4
,Chk_HubbardV3
,Chk_HubbardV2
,Chk_HubbardV1
,Chk_MikeLSD
,Chk_Comptech
,Chk_SoundMaker
,Chk_Electrosound
,Chk_PollyTracker
,Chk_MasterComp
,Chk_Ubik
,Chk_AMP1
,Chk_Boogaloo
,Chk_Bjerregaard1
,Chk_Bjerregaard2
,Chk_ReflexTrk
,Chk_FAME
,Chk_20CC
,Chk_CTExe
,Chk_System6581
,Chk_MattGray
,Chk_PowerMus
,Chk_GRGTiny2
,Chk_Yip
,Chk_TFX1
,Chk_Griff1
,Chk_Griff2
,Chk_Ariston
,Chk_Winterberg
,Chk_Jensen
,Chk_MegaVision
};

/*****************************************************************************/
int Scanners(void)
/*****************************************************************************/
{
    int x,y,z=0;
    y=sizeof(ScanFunc)/sizeof(*ScanFunc);
    for (x=0;x<y;x++)
    {
        z=(ScanFunc[x])();
        if( z )
            break;
    }
    return z;
}

/*****************************************************************************/
int main(int argc, char *argv[])
/*****************************************************************************/
{
    char newfile[MAX_PATH],*z,*q;
    unsigned char *realp;
    FILE *h,*hout;

    if(argc<2)
    {
        printf(
        "PRG2SID "VERSION" (/) iAN CooG/HVSC\n"
        "Usage: p2s <filename.prg> [new_load_addr]\n"
        "a filename.sid will be created\n");
        return 1;
    }
    strcpy(newfile,argv[1]);
    z=strrchr(newfile,'\\');
    if(z)
    {
        q=strrchr(z,'.');
    }
    else
    {
        q=strrchr(newfile,'.');
    }
    if(q)
        *q=0;
    strcat(newfile,".sid");
    h=fopen(argv[1],"rb");
    if(h==NULL)
    {
        printf("error opening %s\n",argv[1]);
        return 2;
    }
    fseek(h,0,SEEK_END);
    fsiz=ftell(h);
    fseek(h,0,SEEK_SET);
    realp=calloc(fsiz,1);
    p=realp;
    if(realp==NULL)
    {
        printf("alloc error??\n");
        fclose(h);
        return 3;
    }
    fread(p,fsiz,1,h);
    fclose(h);
    if(((p[0]==psidh[0])||(p[0]=='R')) &&
        (p[1]==psidh[1]) &&
        (p[2]==psidh[2]) &&
        (p[3]==psidh[3]))
    {
        printf("%s is already a .SID\n",argv[1]);
        free(realp);
        return 2;
    }
    hout=fopen(newfile,"wb");
    if(hout==NULL)
    {
        free(realp);
        printf("error creating %s\n",newfile);
        return 4;
    }
    loadaddr=p[0]|p[1]<<8;
    if( (argc>2) && (strlen(argv[2])>2) )
    {
        j=0;
        if(argv[2][0]=='$')
            j=strtol(argv[2]+1,&q,16);
        else if( (argv[2][0]=='0') && ((argv[2][1]&0xdf)=='X') )
            j=strtol(argv[2]+2,&q,16);
        else
            j=strtol(argv[2],&q,10);
        if((j>loadaddr) && (j<(loadaddr+fsiz-2)))
        {
            k=j-loadaddr;
            p+=k;
            fsiz-=k;
            loadaddr=j;
            p[0]=j&0xff;
            p[1]=j>>8;
        }
    }

    /* default for classic 1000/1003 */
    initaddr=loadaddr;
    playaddr=initaddr+3;
    /* briefly id some particular players */
    Scanners();
    printf("%s: ID=%s Init=$%04x Play=$%04x\n",newfile,ids,initaddr,playaddr);
    psidh[0x0a]=initaddr>>8;
    psidh[0x0b]=initaddr&0xff;
    psidh[0x0c]=playaddr>>8;
    psidh[0x0d]=playaddr&0xff;
    fwrite(psidh,sizeof(psidh),1,hout);
    if(extra)
        fwrite(extrabytes,extra,1,hout);
    fwrite(p,fsiz,1,hout);
    fclose(hout);
    free(realp);
    return 0;
}
